/*  Project: Open Source Gmini Tools
    file: CommentMap.h, header file for CommentMap.cpp

    Copyright (C) 2004  Michael R. Donat <michael@donat.org>
         with contributions by gromit' and Treyqae

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CommentMapH
#define CommentMapH
#include <map>
#include <list>
using namespace std;
#include "types.h"

class CommentMap {
private:
	enum { BUFLEN = 10240 };        // should be big enough for almost any usage
	enum { LINELENGTH = 80 };       // standard terminal width
	enum { MIN_STRING_LENGTH = 3 }; // minimum length for found strings
	map<u32,char*> commentmap;
	map<u32,char*> refcommentmap;
public:
	CommentMap();
	~CommentMap();
	int load( const char* commentfile, u32 baseaddr );
	const char *get( u32 addr, bool atref = false );
	void add( u32 addr, const char* comment, bool atref = false );
	void findStrings( const u8* firmware, u32 length, u32 baseaddr );
	const int dump( const char* file );
};
extern CommentMap* comments;
#endif
