/*  Project: Open Source Gmini Tools
    file: Reference.cpp, list of references to an address

    Copyright (C) 2004  Michael R. Donat <michael@donat.org>
         with contributions by gromit' and Treyqae

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <stdio.h>
#include "Reference.h"
const char Reference::typenames[4][6] = {"DATA", "RJUMP",  "AJUMP", "CALL" };
Reference::Reference( char* sym ) {
   char* temp = new char[strlen(sym) + 1];
   strcpy( temp, sym );
   name = temp;
}
Reference::~Reference() {
   delete name;
}
void Reference::add( u32 from, access type ) {
   if( refs.find( from ) != refs.end() && type != refs[from] )
      printf("Redefining reference from %s to %s\n", typenames[refs[from]], typenames[type] );
   refs[from] = type;
}
const char* Reference::getname() {
   return name;
}
const int Reference::getrefs(char* buf ) {
   map<u32,access>::const_iterator itr = refs.begin();
   int length = 0;
   while( itr != refs.end() ) {
      length += sprintf( buf + length, "%s 0x%06X\n", typenames[itr->second], itr->first);
      ++itr;
   }
   return length;
}

