/*  Project: Open Source Gmini Tools
    file: Reference.h, header file for Reference.cpp

    Copyright (C) 2004  Michael R. Donat <michael@donat.org>
         with contributions by gromit' and Treyqae

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef ReferenceH
#define ReferenceH
#include <map>
using namespace std;
#include "types.h"

class Reference {
public:
   enum access { DATA=0, RJUMP=1,  AJUMP=2, CALL=3 };
   static const char typenames[4][6];
private:
   map<u32, access> refs;
   char* name;
public:
   Reference( char* sym );
   ~Reference();
   void add( u32 from, access type );
   const char* getname();
   const int getrefs( char* buffer);
};
#endif
