/*  Project: Open Source Gmini Tools
    file: SymMap.h, header file for SymMap.cpp

    Copyright (C) 2004  Michael R. Donat <michael@donat.org>
         with contributions by gromit' and Treyqae

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SymMapH
#define SymMapH
#include <map>
using namespace std;
#include "types.h"
#include "Reference.h"

class SymMap {
private:
   enum { BUFLEN = 256 };
   map<u32,Reference*> symmap;
public:
   SymMap();
   ~SymMap();
   int load( const char* mapfile );
   const char *get( u32 addr );
   void addref( u32 from, u32 to, Reference::access type );
   const char *getref( u32 addr, char* buffer  );
   const u32 addrof( char* symbol );
   const int dump( const char* file );
};
extern SymMap* symbols; 
#endif
 
