#include <stdlib.h>
#include <iostream>
using namespace std;
#include "types.h"
#include "MMU.h"
#include "CPUCore.h"
#include "SymMap.h"
#include "CommentMap.h"
#include "parsecmd.h"
#include "BreakpointList.h"

#define DEFAULT_FN "../bin/FirmwareGmini200_v170.bin"
#define DEFAULT_VER CPUCore::gm220v170

MMU memory;
CPUCore cpu(&memory);
BreakpointList BL;
bool cmdexit;
int main( int argc, char* argv[] ) {
	char *fn;
	fn = (argc < 2) ? strdup(DEFAULT_FN) : strdup(argv[1]);
	cout << "Loading " << fn << endl;
	
	u32 loadoffset = 0x6000;
	if( memory.load( fn, loadoffset )) {
		symbols = new SymMap();
//		symbols->load();
		comments = new CommentMap();
		memory.findStrings();
//		comments->load(commentfile);
		cpu.locatefunctions();
		cpu.go( loadoffset + 0x100 );
		cpu.setVersion( DEFAULT_VER );
		startparser();
		while( !cmdexit )
			parsecmd();
		stopparser();
   }
}
 
