%{

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "parsecmd.hpp"

%}
 
bpm			[Bb][Pp][Mm]
bpr			[Bb][Pp][Rr]
bpx			[Bb][Pp][Xx]
clear			[Cc]([Ll]([Ee]([Aa]([Rr])?)?)?)?
delete			[Dd]([Ee]([Ll]([Ee]([Tt]([Ee])?)?)?)?)?
flash			[Ff]([Ll]([Aa]([Ss]([Hh])?)?)?)?
go			[Gg]([Oo])?
help			([Hh]([El]([Ll]([Pp])?)?)?|\?)
image			[Ii]([Mm]([Aa]([Gg]([Ee])?)?)?)?
jog			[Jj]([Og]([Gg])?)?
list			[Ll]([Ii]([Ss]([Tt])?)?)?
mmio			[Mm]([Mm]([Ii]([Oo])?)?)?
ops			[Oo]([Pp]([Ss])?)?
quit			[Qq]([Uu]([Ii]([Tt])?)?)?
ram			[Rr][Aa]([Mm])?
registers		[Rr][Ee]([Gg]([Ii]([Ss]([Tt]([Ee]([Rr]([Ss])?)?)?)?)?|[Ss])?)?
run			[Rr][Uu]([Nn])?
step			[Ss]([Tt]([Ee]([Pp])?)?)?
walk			[Ww][Aa]([Ll]([Kk])?)?
decimal			[0-9]*
hexnum			(0x[0-9a-fA-F]*|[0-9]*H)
read			[Rr]
write			[Ww]
execute			[Xx]
white			[ \t]+
cr			[\n]

%%

{bpm}			{ return(_BPM); }
{bpr}			{ return(_BPR); }
{bpx}			{ return(_BPX); }
{clear}			{ return(_CLEAR); }
{delete}		{ return(_DELETE); }
{flash}			{ return(_FLASH); }
{go}			{ return(_GO); }
{help}			{ return(_HELP); }
{image}			{ return(_IMAGE); }
{jog}			{ return(_JOG); }
{list}			{ return(_LIST); }
{mmio}			{ return(_MMIO); }
{ops}			{ return(_OPS); }
{quit}			{ return(_QUIT); }
{ram}			{ return(_RAM); }
{registers}		{ return(_REGS); }
{run}			{ return(_RUN); }
{step}			{ return(_STEP); }
{walk}			{ return(_WALK); }
{decimal}		{ yylval.address = atoi(yytext+2);
			  return(_NUMBER); }
{hexnum}		{ yylval.address = strtol(yytext+2, NULL, 16);
			  return(_ADDRESS); }
{read}			{ return(_R); }
{write}			{ return(_W); }
{execute}		{ return(_X); }
{white}			{ /* We ignore white characters */ }
{cr}			{ return(_EOL); }			  
